package jp.no_blog.nekokiss;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import java.awt.FlowLayout;
import javax.swing.JLabel;
import java.awt.Font;
import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;
import java.awt.Dimension;
import javax.swing.JButton;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.JCheckBox;
import javax.swing.JScrollPane;
import javax.swing.ScrollPaneConstants;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;
import javax.swing.SwingConstants;
import java.awt.ScrollPane;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.border.MatteBorder;
import java.awt.Color;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;

public final class MainJFrame extends JFrame {

	private final StatusJDialog statusJDialog = new StatusJDialog();
	private Properties properties;
	private String propertiesPath;
	private BusyouName selectedKunsyuName = null;
	private BusyouName selectedHaikaName = null;
	private JPanel contentPane;
	private JSpinner spinner_1;
	private JSpinner spinner;
	private JSpinner spinner_2;
	private JSpinner spinner_3;
	private JCheckBox chckbxNewCheckBox;
	private JLabel label_5;
	private JComboBox comboBox_1;
	private JComboBox comboBox_3;
	private JComboBox comboBox;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				String current = new File( "." ).getAbsoluteFile().getParent();
				if (current.endsWith(File.separator)) {
					System.out.println("ルートディレクトリからは実行できません。");
					return;
				}
				String path = current + File.separator + "san5culc.properties";
				Properties p = new Properties();
				try {
					FileInputStream fis = new FileInputStream(new File(path));
					p.load(fis);
					fis.close();
				} catch (Exception e1) {
					// TODO 自動生成された catch ブロック
					e1.printStackTrace();
				}
				try {
					MainJFrame frame = new MainJFrame();
					try {
						String sx = p.getProperty("x");
						if (sx != null) {
							int x = Integer.parseInt(sx);
							String sy = p.getProperty("y");
							if (sy != null) {
								int y = Integer.parseInt(sy);
								frame.setLocation(x, y);
							}
						}
					} catch (NumberFormatException nfe) {
						nfe.printStackTrace();
					}
					try {
						String skunsyu50 = p.getProperty("kunsyu.50");
						if (skunsyu50 != null) {
							int kunsyu50 = Integer.parseInt(skunsyu50);
							String skunsyuindex = p.getProperty("kunsyu.index");
							if (skunsyuindex != null) {
								int kunsyuindex = Integer.parseInt(skunsyuindex);
								frame.comboBox.setSelectedIndex(kunsyu50);
								frame.comboBox_1.setSelectedIndex(kunsyuindex);
							}
						}
					} catch (NumberFormatException nfe) {
						nfe.printStackTrace();
					}
					frame.properties = p;
					frame.propertiesPath = path;
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public MainJFrame() {
		setResizable(false);
		setTitle("三国志V 忠誠度上昇計算機");
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowOpened(WindowEvent e) {
				// JLabel のサイズを文字列に自動的に合わせるための文
				label_5.setPreferredSize(null);
			}
			@Override
			public void windowClosing(WindowEvent e) {
				properties.setProperty("x", Integer.toString(getX()));
				properties.setProperty("y", Integer.toString(getY()));
				properties.setProperty("kunsyu.50", Integer.toString(comboBox.getSelectedIndex()));
				properties.setProperty("kunsyu.index", Integer.toString(comboBox_1.getSelectedIndex()));
				try {
					properties.store(new FileOutputStream(propertiesPath), null);
				} catch (Exception e1) {
					e1.printStackTrace();
				}
			}
		});
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 320, 400);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
		
		JLabel lblNewLabel = new JLabel("君主");
		lblNewLabel.setFont(new Font("Monospaced", Font.BOLD, 18));
		contentPane.add(lblNewLabel);
		
		comboBox = new JComboBox();
		comboBox.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				selectedTheJapaneseSyllabary(true, (TheJapaneseSyllabary) e.getItem());
			}
		});
		comboBox.setFont(new Font("Monospaced", Font.BOLD, 18));
		comboBox.setMaximumRowCount(16);
		comboBox.setPreferredSize(new Dimension(48, 22));
		comboBox.setModel(new DefaultComboBoxModel(TheJapaneseSyllabary.values()));
		comboBox.setSelectedIndex(0);
		contentPane.add(comboBox);
		
		comboBox_1 = new JComboBox();
		comboBox_1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				selectedBusyou(true, (BusyouName) comboBox_1.getSelectedItem());
			}
		});
		comboBox_1.setMaximumRowCount(16);
		comboBox_1.setPreferredSize(new Dimension(108, 22));
		comboBox_1.setFont(new Font("Monospaced", Font.BOLD, 18));
		contentPane.add(comboBox_1);
		
		JButton btnNewButton = new JButton("Status");
		btnNewButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				showStatus(selectedKunsyuName);
			}
		});
		btnNewButton.setFont(new Font("Monospaced", Font.BOLD, 15));
		contentPane.add(btnNewButton);
		
		JLabel label = new JLabel("相性");
		label.setFont(new Font("Monospaced", Font.BOLD, 18));
		contentPane.add(label);
		
		spinner = new JSpinner();
		spinner.setPreferredSize(new Dimension(56, 22));
		spinner.setModel(new SpinnerNumberModel(0, 0, 150, 1));
		spinner.setFont(new Font("Monospaced", Font.BOLD, 18));
		contentPane.add(spinner);
		
		JLabel label_1 = new JLabel("魅力");
		label_1.setFont(new Font("Monospaced", Font.BOLD, 18));
		contentPane.add(label_1);
		
		spinner_1 = new JSpinner();
		spinner_1.setModel(new SpinnerNumberModel(1, 1, 100, 1));
		spinner_1.setPreferredSize(new Dimension(56, 22));
		spinner_1.setFont(new Font("Monospaced", Font.BOLD, 18));
		contentPane.add(spinner_1);
		
		chckbxNewCheckBox = new JCheckBox("玉璽");
		chckbxNewCheckBox.setFont(new Font("Monospaced", Font.BOLD, 18));
		contentPane.add(chckbxNewCheckBox);
		
		JLabel label_2 = new JLabel("配下");
		label_2.setFont(new Font("Monospaced", Font.BOLD, 18));
		contentPane.add(label_2);
		
		JComboBox comboBox_2 = new JComboBox();
		comboBox_2.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				selectedTheJapaneseSyllabary(false, (TheJapaneseSyllabary) e.getItem());
			}
		});
		comboBox_2.setModel(new DefaultComboBoxModel(TheJapaneseSyllabary.values()));
		comboBox_2.setSelectedIndex(0);
		comboBox_2.setPreferredSize(new Dimension(48, 22));
		comboBox_2.setMaximumRowCount(16);
		comboBox_2.setFont(new Font("Monospaced", Font.BOLD, 18));
		contentPane.add(comboBox_2);
		
		comboBox_3 = new JComboBox();
		comboBox_3.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				selectedBusyou(false, (BusyouName) comboBox_3.getSelectedItem());
			}
		});
		comboBox_3.setPreferredSize(new Dimension(108, 22));
		comboBox_3.setMaximumRowCount(16);
		comboBox_3.setFont(new Font("Monospaced", Font.BOLD, 18));
		contentPane.add(comboBox_3);
		
		JButton button = new JButton("Status");
		button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				showStatus(selectedHaikaName);
			}
		});
		button.setFont(new Font("Monospaced", Font.BOLD, 15));
		contentPane.add(button);
		
		JLabel label_3 = new JLabel("相性");
		label_3.setFont(new Font("Monospaced", Font.BOLD, 18));
		contentPane.add(label_3);
		
		spinner_2 = new JSpinner();
		spinner_2.setModel(new SpinnerNumberModel(0, 0, 150, 1));
		spinner_2.setPreferredSize(new Dimension(56, 22));
		spinner_2.setFont(new Font("Monospaced", Font.BOLD, 18));
		contentPane.add(spinner_2);
		
		JLabel label_4 = new JLabel("忠誠");
		label_4.setFont(new Font("Monospaced", Font.BOLD, 18));
		contentPane.add(label_4);
		
		spinner_3 = new JSpinner();
		spinner_3.setModel(new SpinnerNumberModel(80, 0, 100, 1));
		spinner_3.setPreferredSize(new Dimension(56, 22));
		spinner_3.setFont(new Font("Monospaced", Font.BOLD, 18));
		contentPane.add(spinner_3);
		
		JButton button_1 = new JButton("計算");
		button_1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				// 玉璽
				boolean gyokuji = chckbxNewCheckBox.isSelected();
				// 君主の魅力と、その平方根
				int charm = gyokuji ? 100 : (int) spinner_1.getValue();
				double charmSqrt = (int) Math.sqrt(charm);
				// 両者の相性と相性差と補正
				int kunsyuAffinity = (int) spinner.getValue();
				int haikaAffinity = (int) spinner_2.getValue();
				int diff = Math.abs(kunsyuAffinity - haikaAffinity);
				if (diff > 75) {
					diff = 150 - diff;
				}
				int correction = ((diff + 4) / 5) + 2;
				// 必要な金の平方根
				int moneySqrt = 45;
				int moneySqrt2 = 0;
				// 現在の忠誠度
				int loyalty = (int) spinner_3.getValue();
				// 100 - 現在の忠誠度
				int range = 100 - loyalty;
				// 文字列処理高速化
				StringBuilder sb = new StringBuilder();
				sb.append("<html>君主 ");
				sb.append(comboBox_1.getSelectedItem());
				sb.append(", 相性 ");
				sb.append(kunsyuAffinity);
				if (gyokuji) {
					sb.append(", 玉璽");
				} else {
					sb.append(", 魅力 ");
					sb.append((int) charm);
				}
				sb.append("<br>配下 ");
				sb.append(comboBox_3.getSelectedItem());
				sb.append(", 相性 ");
				sb.append(haikaAffinity);
				sb.append(", 忠誠 ");
				sb.append(loyalty);
				for (int i = range; i > 0; --i) {
					moneySqrt2 = (int) Math.ceil(i * correction / charmSqrt);
					if (moneySqrt > moneySqrt2) {
						moneySqrt = moneySqrt2;
						sb.append(String.format("<br>金&nbsp;%1$4d,&nbsp;+%2$3d,&nbsp;忠誠度&nbsp;%3$3d",
								moneySqrt * moneySqrt, i, i + loyalty).replace(" ", "&nbsp;"));
					}
				}
				// 文字列をセット
				label_5.setText(sb.toString());
			}
		});
		button_1.setFont(new Font("Monospaced", Font.BOLD, 15));
		contentPane.add(button_1);
		
		comboBox_1.setModel(new DefaultComboBoxModel(BusyouName.getNames(TheJapaneseSyllabary.あ)));
		comboBox_1.setSelectedIndex(0);
		selectedBusyou(true, (BusyouName) comboBox_1.getSelectedItem());
		comboBox_3.setModel(new DefaultComboBoxModel(BusyouName.getNames(TheJapaneseSyllabary.あ)));
		comboBox_3.setSelectedIndex(0);
		selectedBusyou(false, (BusyouName) comboBox_3.getSelectedItem());
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setPreferredSize(new Dimension(300, 232));
		contentPane.add(scrollPane);
		
		label_5 = new JLabel();
		label_5.setVerticalAlignment(SwingConstants.TOP);
		scrollPane.setViewportView(label_5);
		label_5.setFont(new Font("Monospaced", Font.PLAIN, 18));
	}
	
	private final void selectedTheJapaneseSyllabary(boolean isKunsyu, TheJapaneseSyllabary key) {
		JComboBox cb = isKunsyu ? comboBox_1 : comboBox_3;
		if (cb.getSelectedItem() == key) {
			return;
		}
		cb.removeAllItems();
		cb.setModel(new DefaultComboBoxModel(BusyouName.getNames(key)));
		cb.setSelectedIndex(0);
	}
	
	private final void selectedBusyou(boolean isKunsyu, BusyouName key) {
		if (key == null) {
			return;
		}
		if (isKunsyu) {
			if (selectedKunsyuName == key) {
				return;
			}
			selectedKunsyuName = key;
			Busyou b = Busyou.get(key);
			spinner.setValue(b.get相性());
			spinner_1.setValue(b.get魅力());
		} else {
			if (selectedHaikaName == key) {
				return;
			}
			selectedHaikaName = key;
			Busyou b = Busyou.get(key);
			spinner_2.setValue(b.get相性());
		}
	}
	
	private final void showStatus(BusyouName key) {
		if (key == null) {
			return;
		}
		statusJDialog.setBusyou(key);
		statusJDialog.setLocationRelativeTo(this);
		statusJDialog.setVisible(true);
	}

}
