package jp.no_blog.nekokiss;

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import java.awt.Font;
import java.awt.CardLayout;
import javax.swing.SwingConstants;
import java.awt.Dialog.ModalityType;
import java.awt.Window.Type;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.Map;
import java.util.TreeMap;

public class StatusJDialog extends JDialog {

	private final Map<BusyouName, String> map = new TreeMap<BusyouName, String>();
	private final JPanel contentPanel = new JPanel();
	private JLabel lblNewLabel;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			StatusJDialog dialog = new StatusJDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public StatusJDialog() {
		setAlwaysOnTop(true);
		setModal(true);
		setResizable(false);
		setTitle("武将");
		setBounds(100, 100, 208, 208);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			lblNewLabel = new JLabel("");
			lblNewLabel.setBounds(5, 5, 194, 139);
			lblNewLabel.setVerticalTextPosition(SwingConstants.TOP);
			lblNewLabel.setHorizontalTextPosition(SwingConstants.LEFT);
			lblNewLabel.setHorizontalAlignment(SwingConstants.LEFT);
			lblNewLabel.setVerticalAlignment(SwingConstants.TOP);
			lblNewLabel.setFont(new Font("Monospaced", Font.PLAIN, 18));
			contentPanel.add(lblNewLabel);
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("Close");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						setVisible(false);
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
		}
	}
	
	public final void setBusyou(BusyouName key) {
		if (map.containsKey(key)) {
			lblNewLabel.setText(map.get(key));
			return;
		}
		Busyou b = Busyou.get(key);
		StringBuilder sb = new StringBuilder();
		sb.append("<html>");
		sb.append(b.get名前());
		sb.append("<br>");
		sb.append(b.get読み());
		sb.append("<br>誕生年&nbsp;");
		sb.append(b.get誕生年());
		sb.append("&nbsp;&nbsp;相性&nbsp;");
		sb.append(String.format("%1$3d", b.get相性()).replace(" ", "&nbsp;"));
		sb.append("<br>武力&nbsp;&nbsp;&nbsp;");
		sb.append(String.format("%1$3d", b.get武力()).replace(" ", "&nbsp;"));
		sb.append("&nbsp;&nbsp;野望&nbsp;&nbsp;");
		sb.append(String.format("%1$2d", b.get野望()).replace(" ", "&nbsp;"));
		sb.append("<br>知力&nbsp;&nbsp;&nbsp;");
		sb.append(String.format("%1$3d", b.get知力()).replace(" ", "&nbsp;"));
		sb.append("&nbsp;&nbsp;義理&nbsp;&nbsp;");
		sb.append(String.format("%1$2d", b.get義理()).replace(" ", "&nbsp;"));
		sb.append("<br>政治&nbsp;&nbsp;&nbsp;");
		sb.append(String.format("%1$3d", b.get政治()).replace(" ", "&nbsp;"));
		sb.append("&nbsp;&nbsp;冷静&nbsp;&nbsp;&nbsp;");
		sb.append(b.get冷静());
		sb.append("<br>魅力&nbsp;&nbsp;&nbsp;");
		sb.append(String.format("%1$3d", b.get魅力()).replace(" ", "&nbsp;"));
		sb.append("&nbsp;&nbsp;勇猛&nbsp;&nbsp;&nbsp;");
		sb.append(b.get勇猛());
		String text = sb.toString();
		map.put(key, text);
		lblNewLabel.setText(text);
	}

}
